GenKeyFile:
	lea si,Nam-1
	mov ax,160
	movzx cx,byte ptr [si]
	inc cx
	sub ax,cx
	lea di,Key
	rep movsb
	xchg ax,cx
	rep stosb
	
	call Make_Mask	
	xor eax,eax
	xor ebx,ebx
	lea si,Key
	mov cx,160
@1:	lodsb
	add ebx,eax
	loop @1
	mov [si],ebx	
	rol ebx,6
	mov Cnt,ebx

	;
	;  ६  樨  㦭 ࠢ  宫⮬ 室
	;
	;  Modifying crypting mask in a right direction via an idle flow.
	;
	mov cx,20*24
@2:	call Next_Cnt
	loop @2

	;
	;  㥬   ஭
	;
	;  Crypting in a backward direction
	;
	
	lea si,Key+160-8
	mov cx,20
@3:	call Crypt_8b
	sub si,8
	loop @3

	lea dx,KeyFile
	mov ax,3C00h
	xor cx,cx
	int 21h
	xchg ax,bx
	lea dx,Key
	mov cx,164
	mov ah,40h
	int 21h
	lea dx,msg_Key
	mov cx,32
	mov ah,40h
	int 21h
	mov ah,3Eh
	int 21h
	retn

;
;      ⮩ 楤,  ய ⮢ 
;    _Mask,    ⠥  .
;
;  It is possible to precalculate this 8 bytes into _Mask field, but
;  let it be for better undestanding.
;
Make_Mask:	cld
		lea	di, _Mask
		mov	al, 55h
		mov	ecx, 8
loc_4025D8:	inc	al
		xor	al, 12h
		stosb
		loop	loc_4025D8
		retn	

;
;  ⭮,  室 ⥪   ᪨ ⮦ 뫨 
;  ᠬ -  ࠩ  ⠪   ࠭  
;  訡.
;
;  I guess that part of source decryptor also contained macros cose
;  it is shoter and free us from mistakes.
;
@Round1		MACRO @x
		mov cl,byte ptr @x
		mov eax,edi
		rol eax,cl
		call Crypt_Next
		xor ebx,eax		
ENDM

@Round2		MACRO @x
		mov cl,byte ptr @x
		mov eax,ebx
		ror eax,cl
		call Crypt_Next
		xor edi,eax		
ENDM

;
;  筮  ᮪  楤   300 - ᢥ
;  24 맮 ᮢ 樨  横  12 権. ⠢
;  ⠪  宦  ਣ   饭 .
;
;  It is possible to reduce this routine at about 300 bytes - roll up
;  24 calls for crypting macros into cycle at 12 iterations.
;  Leaved without changes for better understandig and similarity of
;  source code.
;
Crypt_8b:
		push	ebx
		push	ecx
		push	edx
		push	edi

		mov	edi, [si]
		mov	ebx, [si+4]
		push	esi

		@Round2 _Mask+6
		@Round1 _Mask+4
		@Round2 _Mask+2
		@Round1 _Mask
		@Round2 _Mask+7
		@Round1 _Mask+5
		@Round2 _Mask+3
		@Round1 _Mask+1
		@Round2 _Mask
		@Round1 _Mask+1
		@Round2 _Mask+2
		@Round1 _Mask+3
		@Round2 _Mask+4
		@Round1 _Mask+5
		@Round2 _Mask+6
		@Round1 _Mask+7
		@Round2 _Mask+7
		@Round1 _Mask+6
		@Round2 _Mask+5
		@Round1 _Mask+4
		@Round2 _Mask+3
		@Round1 _Mask+2
		@Round2 _Mask+1
		@Round1 _Mask
		
		pop	esi
		mov	[si], edi
		mov	[si+4], ebx
		pop	edi
		pop	edx
		pop	ecx
		pop	ebx
		retn	

Crypt_Next:
		push	ecx
		call	CntBack
		mov	ecx, Cnt
		shr	ecx, 18h
		ror	eax, cl
		xor	eax, Cnt
		pop	ecx
		retn	

Next_Cnt:	push	eax
		mov	eax, 51656854h	; TheQ
		cdq	
		imul	Cnt
		add	eax, 6D6D482Bh	; +Hmm
		sub	Cnt, eax
		pop	eax
		retn	

CntBack:
		push eax
		mov eax,0011AE425h	; 1/(1-51656854)
		add Cnt,06d6d482Bh
		mul Cnt
		mov Cnt,eax
		pop eax
		retn
