	.model tiny
	.code
	.486
	.startup
	org 100h

;
; slow search (2^31 iterations). takes about 15 minutes
;
; @3:	mov ecx,0FFFFFFFFh
; @1:	mov eax,0AE9A97ADh
;	mul ecx
;	cmp eax,1
;	jz @ok
;	sub ecx,2
;	jnc @1
;	retn

;
; a bit optimized search (32768+65536 <2^17 iterations)
; really, we can make it in an only 896 interations or even 62 but nobody
; need it, i's already quite fast.
;
	mov ecx,0FFFFh
@2:	mov eax,097ADh
	mul ecx
	cmp ax,1
	jz @3
	sub ecx,2
	jnc @2
	retn
		
@3:	or ecx,0FFFF0000h
@1:	mov eax,0AE9A97ADh
	mul ecx
	cmp eax,1
	jz @ok
	sub ecx,10000h
	jnc @1
	retn
@ok:
	mov eax,ecx
	call $ShowEAX
	call $Next_Line
	retn

include debug.inc

end
